"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/nuxt.ts
var nuxt_exports = {};
__export(nuxt_exports, {
  default: () => nuxt_default
});
module.exports = __toCommonJS(nuxt_exports);
var import_kit = require("@nuxt/kit");

// src/vite.ts
var import_unplugin2 = require("unplugin");

// src/core/unplugin.ts
var import_unplugin = require("unplugin");

// src/core/context.ts
var import_node_process2 = __toESM(require("process"), 1);
var import_magic_string = __toESM(require("magic-string"), 1);
var import_vite = require("vite");
var import_xregexp = __toESM(require("xregexp"), 1);

// src/core/directives/if.ts
var import_node_process = __toESM(require("process"), 1);

// src/core/directive.ts
function defineDirective(directive) {
  return directive;
}

// src/core/directives/if.ts
function resolveConditional(test, env = import_node_process.default.env) {
  test = test || "true";
  test = test.trim();
  test = test.replace(/([^=!])=([^=])/g, "$1==$2");
  const evaluateCondition = new Function("env", `with (env){ return ( ${test} ) }`);
  try {
    return evaluateCondition(env);
  } catch (error) {
    if (error instanceof ReferenceError) {
      const match = /(\w*?) is not defined/g.exec(error.message);
      if (match && match[1]) {
        const name = match[1];
        env[name] = false;
        return resolveConditional(test, env);
      }
    }
    return false;
  }
}
var if_default = defineDirective({
  name: "#if",
  nested: true,
  pattern: {
    start: /.*?#if\s([\w !=&|()'"]*).*[\r\n]{1,2}/gm,
    end: /\s*.*?#endif.*?$/gm
  },
  processor({ matchGroup, replace, ctx }) {
    var _a;
    const code = replace(matchGroup.match);
    const regex = /.*?(#el(?:if|se))\s?([\w !=&|()'"]*).*[\r\n]{1,2}/gm;
    const codeBlock = [
      "#if",
      ((_a = matchGroup.left) == null ? void 0 : _a[1]) || "",
      ...ctx.XRegExp.split(code, regex)
    ].map((v) => v.trim());
    while (codeBlock.length) {
      const [variant, conditional, block] = codeBlock.splice(0, 3);
      if (variant === "#if" || variant === "#elif") {
        if (resolveConditional(conditional, ctx.env))
          return block;
      } else if (variant === "#else") {
        return block;
      }
    }
    return "";
  }
});

// src/core/directives/define.ts
var define_default = defineDirective({
  nested: false,
  name: "#define",
  pattern: new RegExp(".*?#(?<directive>(?:un)?def(?:ine)?)\\s*(?<key>[\\w]*)\\s", "gm"),
  processor({ ctx }) {
    return (...args) => {
      const group = args[args.length - 1];
      if (group.directive === "define")
        ctx.env[group.key] = true;
      else if (group.directive === "undef")
        delete ctx.env[group.key];
      return "";
    };
  }
});

// src/core/directives/error.ts
var import_node_path = require("path");
var error_default = defineDirective({
  nested: false,
  name: "#error",
  pattern: new RegExp(".*?#(?<directive>(?:warning)|(?:error)|(?:info))\\s*(?<message>[\\u4E00-\\u9FA5 \\t\\w]*).*?$", "gm"),
  processor({ ctx, id }) {
    return (...args) => {
      const group = args[args.length - 1];
      const source = args[args.length - 2];
      const index = args[args.length - 3];
      const lineNumber = (source.substring(0, index).match(/\n/g) || []).length + 1;
      const file = `${(0, import_node_path.relative)(ctx.cwd, id)}:${lineNumber}`;
      if (group.directive === "warning")
        group.directive = "warn";
      ctx.logger[group.directive](`${file}: ${group.message}`, { timestamp: true });
      return "";
    };
  }
});

// src/core/directives/index.ts
var builtinDirectives = [define_default, if_default, error_default];

// src/core/context.ts
var Context = class {
  constructor({ cwd = import_node_process2.default.cwd(), directives = [], exclude = [/[\\/]node_modules[\\/]/, /[\\/]\.git[\\/]/], include = ["**/*"] } = {}) {
    this.directives = [];
    this.cwd = cwd;
    this.XRegExp = import_xregexp.default;
    this.env = (0, import_vite.loadEnv)(
      import_node_process2.default.env.NODE_ENV || "development",
      cwd,
      ""
    );
    this.directives = [...directives, ...builtinDirectives].map(
      (v) => typeof v === "function" ? v(this) : v
    );
    this.logger = (0, import_vite.createLogger)(void 0, {
      prefix: "unplugin-preprocessor-directives"
    });
    this.filter = (0, import_vite.createFilter)(include, exclude);
  }
  replace({ code, id, directive: _directive }) {
    const directive = _directive;
    return this.XRegExp.replace(code, directive.pattern, directive.processor({
      id,
      code,
      directive,
      ctx: this
    }));
  }
  replaceRecursive({
    code,
    id,
    directive: _directive
  }) {
    const directive = _directive;
    const startRegex = new RegExp(directive.pattern.start, "mi");
    const endRegex = new RegExp(directive.pattern.end, "mi");
    const replace = (code2) => {
      const matches = import_xregexp.default.matchRecursive(
        code2,
        startRegex.source,
        endRegex.source,
        "gmi",
        {
          valueNames: ["between", "left", "match", "right"]
        }
      );
      let builder = "";
      const matchGroup = {
        left: null,
        match: "",
        right: null
      };
      if (!matches.length)
        builder += code2;
      matches.forEach((match) => {
        switch (match.name) {
          case "between":
            builder += match.value;
            break;
          case "left":
            matchGroup.left = startRegex.exec(match.value);
            break;
          case "match":
            matchGroup.match = match.value;
            break;
          case "right":
            matchGroup.right = endRegex.exec(match.value);
            builder += directive.processor({
              id,
              code: code2,
              directive,
              ctx: this,
              replace,
              matchGroup
            });
            break;
        }
      });
      return builder;
    };
    return replace(code);
  }
  createSource(code, id) {
    return new import_magic_string.default(code, {
      filename: id
    });
  }
  transform(code, id) {
    if (!this.filter(id))
      return;
    const source = this.createSource(code, id);
    const data = this.directives.reduce((acc, directive) => {
      const { exclude = [], include = ["**/*"] } = directive;
      const filter = (0, import_vite.createFilter)(include, exclude);
      if (!filter(id))
        return acc;
      acc = directive.nested ? this.replaceRecursive({
        code,
        id,
        directive
      }) : this.replace({
        code: acc,
        id,
        directive
      });
      return acc;
    }, code);
    if (data !== code)
      source.overwrite(0, source.length(), data);
    if (source.hasChanged()) {
      return {
        code: source.toString(),
        map: source.generateMap({
          source: id,
          file: `${id}.map`,
          includeContent: true
        })
      };
    }
  }
};

// src/core/unplugin.ts
var unpluginFactory = (options) => {
  const ctx = new Context(options);
  return {
    name: "unplugin-preprocessor-directives",
    enforce: "pre",
    transform: (code, id) => ctx.transform(code, id),
    vite: {
      configResolved(config) {
        ctx.env = __spreadValues(__spreadValues({}, ctx.env), config.env);
      }
    }
  };
};

// src/vite.ts
var vite_default = (0, import_unplugin2.createVitePlugin)(unpluginFactory);

// src/webpack.ts
var import_unplugin4 = require("unplugin");
var webpack_default = (0, import_unplugin4.createWebpackPlugin)(unpluginFactory);

// src/nuxt.ts
var import_schema = require("@nuxt/schema");
var nuxt_default = (0, import_kit.defineNuxtModule)({
  meta: {
    name: "nuxt-unplugin-preprocessor-directives",
    configKey: "unpluginManifest"
  },
  defaults: {
    // ...default options
  },
  setup(options, _nuxt) {
    (0, import_kit.addVitePlugin)(() => vite_default(options));
    (0, import_kit.addWebpackPlugin)(() => webpack_default(options));
  }
});
exports.default = module.exports;